package net.wanji.opt.dao.mapper.eventoptimize;


import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import net.wanji.opt.entity.eventoptimize.TEventOptimizeInfo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

@Mapper
public interface TEventOptimizeInfoMapper extends BaseMapper<TEventOptimizeInfo> {
    Page<TEventOptimizeInfo> selectPageWithConditions(@Param("page") Page<TEventOptimizeInfo> page,
                                                      @Param("startTime") String startTime,
                                                      @Param("endTime") String endTime,
                                                      @Param("crossId") String crossId,
                                                      @Param("eventType") String eventType,
                                                      @Param("optStatus") Integer optStatus,
                                                      @Param("duration") Integer duration,
                                                      @Param("startOptDuration") Integer startOptDuration,
                                                      @Param("endOptDuration") Integer endOptDuration,
                                                      @Param("startDuration") Integer startDuration,
                                                      @Param("endDuration") Integer endDuration
                                                      );

      Page<TEventOptimizeInfo> selectPageWithCrossIdAndGreenId(@Param("page") Page<TEventOptimizeInfo> page,
                                                      @Param("startTime") String startTime,
                                                      @Param("endTime") String endTime,
                                                      @Param("crossId") String crossId,
                                                      @Param("greenId") Integer greenId);

    List<Map<String,String>> getCrossOptimizeDistribute(@Param("groupType") Integer groupType,
                                                        @Param("startTime") String startTime,
                                                        @Param("endTime") String endTime,
                                                        @Param("crossId") String crossId,
                                                        @Param("greenId") Integer greenId);

    String getEventLabel(@Param("eventType") String eventType);

    Page<TEventOptimizeInfo> pageWithLineConditions(@Param("page") Page<TEventOptimizeInfo> page,
                                                    @Param("startTime") String startTime,
                                                    @Param("endTime") String endTime,
                                                    @Param("greenId") Integer greenId,
                                                    @Param("eventType") String eventType,
                                                    @Param("optStatus") Integer optStatus,
                                                    @Param("duration") Integer duration,
                                                    @Param("startOptDuration") Integer startOptDuration,
                                                    @Param("endOptDuration") Integer endOptDuration,
                                                    @Param("startDuration") Integer startDuration,
                                                    @Param("endDuration") Integer endDuration
                                                    );
}